<script lang="ts">
  import { onMount, onDestroy } from 'svelte';
  import { Tooltip } from '@sveltestrap/sveltestrap';
  import type { EventConfiguration } from '@models/EventConfigurations';
  import { createEventDispatcher } from 'svelte';

  export let id: string | null = null;
  export let eventCfg: EventConfiguration | null;
  export let placement = 'bottom';
  export let size = 15;
  export let displayText = false;
  let timerEnd: Date;
  $: size1 = `${Math.floor(size)}px`;
  $: size1_5 = `${Math.floor(size * (1 / 2))}px`;
  $: size1_33 = `${Math.floor(size * (1 / 3))}px`;
  $: size1_125 = `${Math.floor(size * (1 / 6))}px`;
  let interval: NodeJS.Timer;
  // Display times
  const total = 0;
  let days = Math.random() % 10;
  let hours = Math.random() % 10;
  let minutes = Math.random() % 10;
  let seconds = Math.random() % 10;
  let timerText = 'Time is up!';

  const dispatch = createEventDispatcher();

  onMount(async () => {
    function updateClock() {
      const t = getTimeRemaining(timerEnd);
      if (eventCfg?.start && Date.now() > Date.parse(eventCfg.start)) {
        dispatch('eventStarted');
      }

      days = t.days;
      hours = t.hours;
      minutes = t.minutes;
      seconds = t.seconds;

      if (t.total <= 0) {
        days = 0;
        hours = 0;
        minutes = 0;
        seconds = 0;
        clearInterval(interval);
      }
    }

    await updateTimer();
    updateClock();
    interval = setInterval(updateClock, 1000);
  });

  onDestroy(() => {
    clearInterval(interval);
  });

  function getTimeRemaining(endtime) {
    const t = Date.parse(endtime) - Date.now();
    return {
      total: t,
      days: Math.floor(t / (1000 * 60 * 60 * 24)),
      hours: Math.floor((t / (1000 * 60 * 60)) % 24),
      minutes: Math.floor((t / 1000 / 60) % 60),
      seconds: Math.floor((t / 1000) % 60),
    };
  }

  function getTimerParams(eventCfg: EventConfiguration, now: number) {
    // Before the event starts
    if (eventCfg?.start && now < Date.parse(eventCfg.start)) {
      return { text: 'Event opens in', end: new Date(eventCfg.start) };
    }
    // Check if now is before any of the scoring breaks
    // This code depends on breaks being sorted by start then end and having
    // no overlapping breaks.
    for (let i of eventCfg?.breaks || []) {
      if (now < Date.parse(i.start)) {
        // If before break period
        return { text: 'Scoring break in', end: new Date(i.start) };
      } else if (now >= Date.parse(i.start) && now < Date.parse(i.end)) {
        // If within the break period
        return { text: 'Scoring break over in', end: new Date(i.end) };
      }
    }
    // No more scoring breaks, only the end of the event left to check
    if (eventCfg?.end && now < Date.parse(eventCfg.end)) {
      return { text: 'Event is over in', end: new Date(eventCfg.end) };
    } else {
      return { text: 'Event is over, go home!', end: new Date(0) };
    }
  }

  async function updateTimer() {
    const now = Date.now();
    if (eventCfg) {
      const ret = getTimerParams(eventCfg, now);
      timerText = ret.text;
      timerEnd = ret.end;
      setTimeout(() => {
        updateTimer();
      }, timerEnd.valueOf() - now);
    }
  }
</script>

{#if displayText}
  <h1>{timerText}</h1>
{/if}

<div {id} class="countdown" style="--size1: {size1_125};--size2: {size1_33};--size3: {size1_5};--size4: {size1}">
  <Tooltip target={id} {placement}>{timerText}</Tooltip>
  {#if days > 0}
    <div>
      <div>{String(days).padStart(2, '0')}</div>
      <div>Days</div>
    </div>
  {/if}
  {#if days != 0 || hours > 0}
    <div>
      <div>{String(hours).padStart(2, '0')}</div>
      <div>Hours</div>
    </div>
  {/if}
  <div>
    <div>{String(minutes).padStart(2, '0')}</div>
    <div>Minutes</div>
  </div>
  <div>
    <div>{String(seconds).padStart(2, '0')}</div>
    <div>Seconds</div>
  </div>
</div>

<style>
  * {
    color: #eee;
    text-align: center;
    font-weight: 100;
    font-family: sans-serif;
  }
  .countdown {
    display: flex;
    justify-content: center;
    align-items: center;
    flex-wrap: nowrap;
  }
  .countdown > div {
    padding: var(--size2);
    margin: var(--size1);
    background: #1e1e1e;
  }
  .countdown div > div:first-child {
    padding: var(--size2);
    font-size: var(--size4);
    background: #0a0a0a;
  }
  .countdown div > div:nth-child(2) {
    padding-top: var(--size1);
    font-size: var(--size3);
  }
</style>
